﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Diagnostics;
using System.Threading;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public bool receive = false;

        private string ip, camU, camP, admU, admP;  //IPアドレス、カメラユーザー、カメラパス、管理者ユーザー、管理者パス
        private int po, servPo;                     //カメラポート、待ちうけポート
        private string appPath;
        private bool useProx; 
        private Thread thSession, thEndSession, thVideo;
        private string app_path_vlc;                // VLCの起動パス
        private bool useVLC_;

        private Process proc;           // VLCの起動プロセス
        public CookieContainer cookie_; // 
        public Socket server, client;   // 要求元の要求を受け付けるソケット、要求元にデータを送信するソケット

        private static Form1 f1_;

        public static Form1 F1Instance { get { return f1_; } set { f1_ = value; } }

        /////////　Form1外からForm1内の各変数にアクセスするための仕組み //////////////
        public bool receiving { get { return receive; } set { receive = value; } }                              // 現在受信中かどうか
        public string applicationPath { get {return appPath;} set {appPath = value;}}                           // このアプリケーションの実行パス
        
        public string applicationPath_to_VLC { get { return app_path_vlc; } set { app_path_vlc = value; } }     // VLCの実行ファイルのパス
        public bool useVLC { get { return useVLC_; } set { useVLC_ = value; } }                                 // VLCを連動させるかどうか

        public string ipAddr { get { return ip; } set { ip = value; } }                     // IPアドレス
        public int port { get { return po; } set { po = value; } }                          // ポート番号
        public string camuser { get { return camU; } set { camU = value; } }                // ユーザー名
        public string campass { get { return camP; } set { camP = value; } }                // パスワード

        public string adminuser { get { return admU; } set { admU = value; } }              // 管理者ユーザー名
        public string adminpass { get { return admP; } set { admP = value; } }              // 管理者パスワード
        
        public int serverPort { get { return servPo; } set { servPo = value; } }            // localhost上の待ちうけポート                        //
        public bool useProxy { get { return useProx; } set { useProx = value; } }           // プロキシを使うかどうか
        /////////////////////////////////////////////////////////////////////////////

        // フォーム上の各アイテム
        public string text_ipAddr { get { return textBox_ipAddr.Text; } set { textBox_ipAddr.Text = value; } }                  // カメラのIPアドレス
        public decimal numeric_Port { get { return numeric_port.Value; } set { numeric_port.Value = value; } }                  // カメラのポート
        
        public string text_user { get { return textBox_user.Text; } set { textBox_user.Text = value; } }                        // ユーザー名
        public string text_pass { get { return textBox_pass.Text; } set { textBox_pass.Text = value; } }                        // パスワード

        public string text_adminUser { get { return textBox_adminUser.Text; } set { textBox_adminUser.Text = value; } }         // 管理者ユーザー名
        public string text_adminPass { get { return textBox_adminPass.Text; } set { textBox_adminPass.Text = value; } }         // 管理者パスワード
        
        public decimal numeric_ServPort { get { return numeric_ServerPort.Value; } set { numeric_ServerPort.Value = value; } }  // localhost上の待ちうけポート
        public bool checkBox_useProxy { get { return checkBox1.Checked; } set { checkBox1.Checked = value; } }
        public bool checkBox_useVLC { get { return checkBox2.Checked; } set { checkBox2.Checked = value; } }
        /////


        public Form1()
        {
            InitializeComponent();
            f1_ = this;
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            // ローカルネットワーク内のカメラを検索
            camSearchClass cSC = new camSearchClass();
            
            listBox_Cam.Items.Clear();

            string[] result = cSC.searchCamera(camSearchClass.MULTICAST_IP, camSearchClass.MULTICAST_PORT, camSearchClass.DEFAULT_RECEIVE_PORT, 4, 1000);
            
            if (result != null) {

                for (int i=0; i < result.Count(); i++) {
                    listBox_Cam.Items.Add(result[i]);
                }
            }

            cSC = null;

            // アプリケーション実行パスの取得
            applicationPath = Application.ExecutablePath;
            applicationPath = applicationPath.Substring(0, applicationPath.LastIndexOf(@"\"));
            applicationPath_to_VLC = applicationPath;

            // 各種設定の読み込み
            xmlClass xmlC = new xmlClass();
            xmlC.readSetting(applicationPath + @"\" + constClass.SETTING_FILENAME);
            ipAddr = textBox_ipAddr.Text;
            port = (int)numeric_port.Value;
            camuser = textBox_user.Text;
            campass = textBox_pass.Text;
            serverPort = (int)numeric_ServerPort.Value;
            adminuser = textBox_adminUser.Text;
            adminpass = textBox_adminPass.Text;

            ServicePointManager.DefaultConnectionLimit = 20;    // HTTPの同時接続数を増やす
            label_URL.Text = string.Format("http://localhost:{0}/からストリームを取り出せます", numeric_ServerPort.Value);
        }


        // 受信ボタンを押したときの動作
        private void button1_Click(object sender, EventArgs e)
        {
            if (receiving == false) 
            {
                if (useVLC == true) { // VLCを使う設定の場合は、VLCのパスをチェックして、ファイルが存在するか確認する
                    if (File.Exists(applicationPath_to_VLC) == false) {
                        MessageBox.Show("vlc.exeが見つかりません。パスの設定(vlc.exeの場所)を確認してください");
                        return;
                    }
                }

                receiving = true;               // 受信中フラグを立てる
                formState_Change(receiving);    // ボタンの表示状態を更新する
            } 
            else 
            {
                // VLCを起動している場合は終了させる(とりあえず封印)
                //if (proc != null) {
                //    if (proc.HasExited == false) {

                //        Thread thKillProc = new Thread(delegate() {
                //            proc.Kill();
                //            proc = null;
                //        });
                //        thKillProc.Start();
                //    }
                //}

                receiving = false;              // 受信中フラグを解除する
                formState_Change(receiving);    // ボタンの表示状態を更新する

                thEndSession = new Thread(delegate()   //接続終了をカメラに通知する  
                {
                    endSession(constClass.PROTOCOL, ipAddr, port, constClass.URL_SESSION_END, cookie_, useProxy); 
                });
                thEndSession.Start();

                // 後始末
                if (thSession != null) { thSession.Abort(); }
                if (thVideo != null) { thVideo.Abort(); }
                if (server != null) { server.Close(); }
                if (client != null) { client.Close(); }

                return;                         // 受信終了なのでこれ以上は何もせずに終了する
            }

            try { // 初回のセッションを取得する
                cookie_ = getSession(constClass.PROTOCOL, ipAddr, port, constClass.URL_SESSION_START_USER, camuser, campass, useProxy);
            }
            catch (WebException wex)
            {
                dispSessionErrorMessage(wex);   //エラー発生時は
                return;
            }


            thSession = new Thread(delegate() {  // セッションを定期的に更新するスレッド
                continueSession(constClass.PROTOCOL, ipAddr, port, constClass.URL_CONTINUE_SESSION, cookie_, useProxy);
            });
            thSession.Start();

             thVideo = new Thread(delegate() { // Mpeg2TSストリームを取得するスレッド
                 getM2TS(constClass.PROTOCOL, ipAddr, port, serverPort, constClass.URL_M2TS, cookie_, useProxy);
            });
            thVideo.Start();


            // VLCを起動する
            if (useVLC == true)
            {
                if (proc == null)   // VLC未起動の場合は起動する
                {
                    proc = new Process();
                    proc.StartInfo.FileName = applicationPath_to_VLC;	                                        //起動するファイル名
                    proc.StartInfo.Arguments = constClass.PROTOCOL + constClass.LOCALHOST + ":" + serverPort + " --deinterlace=-1 --no-video-title-show --qt-minimal-view";	//起動時の引数
                    proc.Start(); //プロセス開始
                }
                else {
                    if (proc.HasExited == true) { // VLCが既に閉じられている場合は再び起動する
                        proc.StartInfo.FileName = applicationPath_to_VLC;	                                        //起動するファイル名
                        proc.StartInfo.Arguments = constClass.PROTOCOL + constClass.LOCALHOST + ":" + serverPort + " --deinterlace=-1 --no-video-title-show --qt-minimal-view";	//起動時の引数
                        proc.Start(); //プロセス開始                    
                    }
                }
            }

        }


        // セッションを取得する関数 //
        CookieContainer getSession
            (string protocol, string ipAddr, int port, string url, string user, string pass, bool useProxy_ = false) {

                string uri = protocol + user + ":" + pass + "@" + ipAddr + ":" + port + url;
                CookieContainer cookie = new CookieContainer();
                HttpWebRequest hReq;
                HttpWebResponse hRes;

                hReq = (HttpWebRequest)HttpWebRequest.Create(uri);
                hReq.CookieContainer = cookie;
                hReq.Credentials = new NetworkCredential(user, pass);
                hReq.KeepAlive = false;

                if (useProxy_ == true)
                {
                    hReq.Proxy = System.Net.WebRequest.GetSystemWebProxy();
                }
                else
                {
                    hReq.Proxy = null;
                }

                try
                {
                    hRes = (HttpWebResponse)hReq.GetResponse();
                }
                catch
                {
                    throw;
                }
                finally {
                    hReq.Abort();   // Abortしないと以降のHTTP Requestがタイムアウトするので確実に
                }
                return cookie;
        }


        // セッションを更新する関数
        void continueSession (string protocol, string ipAddr, int port, string url, CookieContainer cookie,bool useProxy_=false)
        {

            string uri = protocol + ipAddr + ":" + port + url;
            HttpWebRequest hReq;
            HttpWebResponse hRes;

            while (receiving == true)
            {
                Thread.Sleep(10000);
                
                hReq = (HttpWebRequest)HttpWebRequest.Create(uri);
                hReq.CookieContainer = cookie;
                hReq.KeepAlive = false;

                if (useProxy_ == true)
                {
                    hReq.Proxy = System.Net.WebRequest.GetSystemWebProxy();
                }
                else
                {
                    hReq.Proxy = null;
                }

                try
                {
                    hRes = (HttpWebResponse)hReq.GetResponse();
                    Console.WriteLine("Cookie更新");
                }catch {
                    
                } finally {
                    hReq.Abort();   // Abortしないと以降のHTTP Requestがタイムアウトするので確実に
                }

            }

        }


        // カメラに接続終了を通知する関数
        void endSession(string protocol, string ipAddr, int port, string url, CookieContainer cookie,bool useProxy_ = false) {
            string uri = protocol + ipAddr + ":" + port + url;
            HttpWebRequest hReq;
            HttpWebResponse hRes;

            hReq = (HttpWebRequest)HttpWebRequest.Create(uri);
            hReq.CookieContainer = cookie;
            hReq.KeepAlive = false;

            if (useProxy_ == true)
            {
                hReq.Proxy = System.Net.WebRequest.GetSystemWebProxy();
            }
            else {
                hReq.Proxy = null;
            }

            try
            {
                hRes = (HttpWebResponse)hReq.GetResponse();
                Console.WriteLine("セッション終了");

            }
            catch (WebException wex)
            { 
                // セッション終了時に接続エラーが発生してもアプリケーションには通知しない。(デバッグのためコンソールにのみ出力する)
                Console.WriteLine("セッション終了時にエラー発生 : " + wex);
            }
            finally {
                hReq.Abort();   // Abortしないと以降のHTTP Requestがタイムアウトするので確実に
            }

        }


        void getM2TS(string protocol, string ipAddr, int port, int serverPorts, string url, CookieContainer cookie, bool useProxy_ = false) 
        {

            Stream netStream;
            HttpWebRequest hReq;
            HttpWebResponse hRes;
            byte[] requestBuffer = new byte[1024];     // 要求元のメッセージを受け取るためのバッファ
            byte[] receiveBuffer = new byte[1024000];  // カメラからストリムを読み出すためのバッファ
            byte[] sendBytes;   //要求元にデータを送信するためのバッファ

            IPAddress ip;
            IPEndPoint ipEndPoint;
            MemoryStream ms = new MemoryStream();

            string httpHeader = String.Format(            // 送信用HTTPヘッダー
                                    "HTTP/1.1 200 OK\r\n" +
                                    "Content-type: video/mpeg\r\n" +
                                    "Transfer-Encoding: chunked\r\n");
            byte[] httpHeaderBuffer = Encoding.ASCII.GetBytes(httpHeader);

            string uri = protocol + ipAddr + ":" + port + url;


        init: // 初期状態

            server = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            ip = IPAddress.Parse(constClass.LOCALHOST);
            ipEndPoint = new IPEndPoint(ip, serverPorts);

            server.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, 1);
            server.Bind(ipEndPoint);
            server.Listen(5);

            client = server.Accept();       // 送信用のソケットを生成
            client.SendTimeout = 5000;     // 送信タイムアウトを無制限に設定する
            client.ReceiveTimeout = 5000;  // 受信タイムアウトを10秒で設定する

            ms.SetLength(0);                // メモリストリームを初期化

            // リクエストが発生するまでの待つ
            int recvLen = -1;
//            int recvLen = client.Receive(requestBuffer);

            while (receiving == true & recvLen <= 0) {
                try
                {
                    recvLen = client.Receive(requestBuffer);
                }
                catch {
                    goto init;
                }
                Thread.Sleep(10);
            }

            Console.Write(Encoding.ASCII.GetString(requestBuffer, 0, recvLen)); // リクエスト内容を表示

            // 応答内容送信
            client.Send(httpHeaderBuffer);

            // プログラム→カメラの要求作成
            hReq = (HttpWebRequest)HttpWebRequest.Create(uri);
            hReq.CookieContainer = cookie;
            hReq.Method = "GET";
            hReq.UserAgent = constClass.USERAGENT;
            hReq.KeepAlive = true;

            if (useProxy_ == true)
            {
                hReq.Proxy = System.Net.WebRequest.GetSystemWebProxy();
            }
            else
            {
                hReq.Proxy = null;
            }

            while (receiving == true)
            {
                try
                {
                    hRes = (HttpWebResponse)hReq.GetResponse();
                    netStream = hRes.GetResponseStream();

                    int nsReadSize = -1;
                    
                    while (nsReadSize != 0) //ネットワークストリームから読み込めたデータがある場合は要求元に送信する
                    {
                        nsReadSize = netStream.Read(receiveBuffer, 0, receiveBuffer.Length);

                        if (nsReadSize != 0)
                        {   
                            // 一回のストリーム読み込みで得たデータを、１つのチャンクデータとして送信する

                            string chunkSize = nsReadSize.ToString("x"); // チャンクサイズを16進で取得

                            ms.Write(Encoding.ASCII.GetBytes("\r\n"), 0, 2);    // 改行コード
                            ms.Write(Encoding.ASCII.GetBytes(chunkSize), 0, chunkSize.Length);  //チャンクサイズ(16進)
                            ms.Write(Encoding.ASCII.GetBytes("\r\n"), 0, 2);    // 改行コード
                            ms.Write(receiveBuffer, 0, nsReadSize);             // ストリームデータ
                            sendBytes = ms.ToArray();                           // 送信用のバイト配列に変換
                            ms.SetLength(0);

                            try
                            { // データ送信
                                client.Send(sendBytes);
                            }
                            catch
                            { //エラー発生時はネットワークを閉じて最初に戻る
                                hReq.Abort();
                                server.Close();
                                client.Close();
                                goto init;                                      // リクエスト待ち状態へ
                            }
                        }
                    }

                } catch (WebException wex){ // エラー発生時はネットワークを閉じて最初に戻る
                    Console.Write(wex);
                    hReq.Abort();
                    server.Close();
                    client.Close();

                    hReq = null;
                    server = null;
                    client = null;

                    goto init;
                }
                Thread.Sleep(10);
            }

            // 受信終了時はネットワークを閉じて終了する
            hReq.Abort();
            server.Close();
            client.Close();
        }


        private void formState_Change(bool receiving_) {

            textBox_ipAddr.Enabled = !receiving;
            textBox_user.Enabled = !receiving;
            textBox_pass.Enabled = !receiving;
            numeric_port.Enabled = !receiving;
            numeric_ServerPort.Enabled = !receiving;
            button_CamSearch.Enabled = !receiving;
            listBox_Cam.Enabled = !receiving;
            checkBox1.Enabled = !receiving;
            checkBox2.Enabled = !receiving;
            button2.Enabled = !receiving;

            if (receiving_ == true) {
                button1.Text = "受信停止";
            } else {
                button1.Text = "受信";
            }
        }



        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            xmlClass xmlC = new xmlClass();
            xmlC.writeSetting(applicationPath + @"\" + constClass.SETTING_FILENAME);    // 設定の保存

            if (receiving == true) {    // 受信中に閉じようとした場合は、終了するか確認する

                DialogResult a = MessageBox.Show(this,"受信中です。終了しますか？","確認",MessageBoxButtons.OKCancel);

                if (a == DialogResult.Cancel)
                {
                    e.Cancel = true;
                } else {
                    thEndSession = new Thread(delegate()    // 終了する場合はセッションを閉じる
                    {
                        endSession(constClass.PROTOCOL, ipAddr, port, constClass.URL_SESSION_END, cookie_);
                    });
                    thEndSession.Start();
                }
            }

            // 後始末 //
            if (thSession != null) { thSession.Abort(); }
            if (thVideo != null) { thVideo.Abort(); }
            if (server != null) { server.Close(); }
            if (client != null) { client.Close(); }

            return;
        }


        // セッション取得時にエラーが発生した場合のメッセージ表示
        private void dispSessionErrorMessage(WebException wex)
        {
            if (wex.Status == WebExceptionStatus.ProtocolError)
            {
                HttpWebResponse err = (HttpWebResponse)wex.Response;

                switch (err.StatusCode)
                {
                    case HttpStatusCode.Unauthorized:       // 401(認証失敗)の場合
                        MessageBox.Show(constClass.MESSAGE_AUTH_ERROR);
                        break;
                    case HttpStatusCode.ServiceUnavailable: // 503 (サーバーエラー)の場合
                        MessageBox.Show(constClass.MESSAGE_SERVER_ERROR);
                        break;
                    default:
                        Debug.WriteLine(err.StatusCode);
                        break;
                }
                receiving = false;
                formState_Change(receiving);
                return;
            }
            else
            {
                if (wex.Status == WebExceptionStatus.Timeout)
                {
                    MessageBox.Show(constClass.MESSAGE_TIMEOUT_ERROR);
                    receiving = false;
                    formState_Change(receiving);
                    return;
                }
                else
                {
                    MessageBox.Show(constClass.MESSAGE_OTHER_ERROR);
                    Console.WriteLine(wex);
                    receiving = false;
                    formState_Change(receiving);
                    return;
                }
            }
        }


        // カメラ検索のボタンを押したときの動作
        private void button_CamSearch_Click(object sender, EventArgs e)
        {

            button_CamSearch.Enabled = false;   // 一時的にボタンを押せなくする

            camSearchClass cSC = new camSearchClass();

            listBox_Cam.Items.Clear();          // カメラの一覧を一旦クリアする

            string[] result = cSC.searchCamera(camSearchClass.MULTICAST_IP,camSearchClass.MULTICAST_PORT,camSearchClass.DEFAULT_RECEIVE_PORT,4,1000);

            if (result == null) { return; }     // カメラが見つからない場合はなにもせず終了する

            for (int i = 0; i < result.Count() ; i++) { // 見つかったカメラを一覧に反映する
                listBox_Cam.Items.Add(result[i]);
            }

            button_CamSearch.Enabled = true;    // ボタンを有効に戻す
        }


        // カメラの一覧をクリックしたときの動作
        private void listBox_Cam_Click(object sender, EventArgs e)
        {            
            if (listBox_Cam.SelectedItems.Count >= 1) {
                
                DialogResult a = MessageBox.Show(this, "選択されたカメラを登録します", "確認", MessageBoxButtons.OKCancel);

                if (a == DialogResult.OK) {
                    string[] datas = listBox_Cam.Text.Split(':');
                    textBox_ipAddr.Text = datas[0];
                    numeric_port.Value = decimal.Parse(datas[1]);
                }
            }
        }


        // フォームを最小化したときの動作
        private void Form1_Resize(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Minimized){ // 最小化されたときはウィンドウを非表示にし、タスクトレイにアイコンを表示する
                this.Visible = false;
                notifyIcon1.Visible = true;           
            }
        }


        // タスクトレイのアイコンをダブルクリックしたときの動作
        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            this.Visible = true;        // ウィンドウを通常状態に戻し、タスクトレイのアイコンを消す
            this.WindowState = FormWindowState.Normal;
            this.notifyIcon1.Visible = false;
        }


        // VLCのパス設定ボタンを押したときの動作
        private void button2_Click(object sender, EventArgs e)
        {
            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "VLC実行ファイル(" + constClass.DEFAULT_VLC_EXE + ")|" + constClass.DEFAULT_VLC_EXE + "|すべてのファイル(*.*)|*.*";
            fd.FileName = constClass.DEFAULT_VLC_EXE;
            fd.InitialDirectory = applicationPath_to_VLC;
            // fd.RestoreDirectory = true;

            DialogResult a = fd.ShowDialog();

            if (a == DialogResult.OK) {
                applicationPath_to_VLC = fd.FileName;                
            } 
        }


        ////// フォーム内のアイテムの状態が変化したときの動作 //
        // プロキシ使用の有無 //
        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            useProxy = checkBox1.Checked;
        }
        // IPアドレス //
        private void textBox_ipAddr_TextChanged(object sender, EventArgs e)
        {
            ipAddr = textBox_ipAddr.Text;
        }
        // ポート番号 //
        private void numeric_port_ValueChanged(object sender, EventArgs e)
        {
            port = (int)numeric_port.Value;
        }
        // ユーザー名 //
        private void textBox_user_TextChanged(object sender, EventArgs e)
        {
            camuser = textBox_user.Text;
        }
        // パスワード //
        private void textBox_pass_TextChanged(object sender, EventArgs e)
        {
            campass = textBox_pass.Text;
        }
        // 管理者ユーザー名 //
        private void textBox_adminUser_TextChanged(object sender, EventArgs e)
        {
            adminuser = textBox_adminUser.Text;
        }
        // 管理者パスワード //
        private void textBox_adminPass_TextChanged(object sender, EventArgs e)
        {
            adminpass = textBox_adminPass.Text;
        }
        // 待ちうけポート //
        private void numeric_ServerPort_ValueChanged(object sender, EventArgs e)
        {
            serverPort = (int)numeric_ServerPort.Value;
            label_URL.Text = string.Format("http://localhost:{0}/からストリームを取り出せます", numeric_ServerPort.Value);
        }
        // VLC使用の有無
        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            useVLC = checkBox2.Checked;
        }

        private void button_Stream_Click(object sender, EventArgs e)
        {
            Form2 fm2 = new Form2();
            fm2.ShowDialog();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Form3 fm3 = new Form3();
            fm3.ShowDialog();
        }





    }
}
