﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Threading;
using System.IO;
using System.Net;


namespace WindowsFormsApplication1
{
    public partial class Form2 : Form
    {

        [DataContract]  // ストリーム設定コマンド
        public class setStreamCmd{
            [DataMember(Name="Command",Order=0)] public string Command { get; set; }
            [DataMember(Name = "Params", Order = 1)] public setStreamCmdParams Data { get; set; }
        }
        [DataContract]
        public class setStreamCmdParams {
            [DataMember (Name="format",Order=0)] public string format { get; set; }
            [DataMember(Name="rate",Order=1)] public string rate { get; set; }
        }
        ///// カメラの情報を受け取る  ///////////////
        [DataContract]
        public class Cam_Feat
        {
            [DataMember(Order = 0, Name = "Requested")]
            public string Requested { get; set; }
            [DataMember(Order = 1, Name = "Result")]
            public string Result { get; set; }
            [DataMember(Order = 2, Name = "Data")]
            public Cam_Feat_Data Data { get; set; }
        }
        [DataContract]
        public class Cam_Feat_Data
        {
            [DataMember(Order = 0, Name = "CamVer")]
            public int CamVer { get; set; }
            [DataMember(Order = 1, Name = "IsAdmin")]
            public string IsAdmin { get; set; }
            [DataMember(Order = 2, Name = "HasMechaPanTilt")]
            public bool HasMechaPanTilt { get; set; }
            [DataMember(Order = 3, Name = "MechaPanMax")]
            public int MechaPanMax { get; set; }
            [DataMember(Order = 4, Name = "MechaPanMin")]
            public int MechaPanMin { get; set; }
            [DataMember(Order = 5, Name = "MechaTiltMax")]
            public int MechaTiltMax { get; set; }
            [DataMember(Order = 6, Name = "MechaTiltMin")]
            public int MechaTiltMin { get; set; }
            [DataMember(Order = 7, Name = "MechaSpeedMax")]
            public int MechaSpeedMax { get; set; }
            [DataMember(Order = 8, Name = "MechaSpeedMin")]
            public int MechaSpeedMin { get; set; }
            [DataMember(Order = 9, Name = "DeciZoomMax")]
            public int DeciZoomMax { get; set; }
            [DataMember(Order = 10, Name = "DeciZoomMin")]
            public int DeciZoomMin { get; set; }
            [DataMember(Order = 11, Name = "HasDegitalPanTilt")]
            public bool HasDegitalPanTilt { get; set; }
            [DataMember(Order = 12, Name = "DegitalXMax")]
            public int DegitalXMax { get; set; }
            [DataMember(Order = 13, Name = "DegitalXMin")]
            public int DegitalXMin { get; set; }
            [DataMember(Order = 14, Name = "DegitalYMax")]
            public int DegitalYMax { get; set; }
            [DataMember(Order = 15, Name = "DegitalYMin")]
            public int DegitalYMin { get; set; }
            [DataMember(Order = 16, Name = "DigitalDeciZoomMax")]
            public int DigitalDeciZoomMax { get; set; }
            [DataMember(Order = 17, Name = "DigitalDeciZoomMin")]
            public int DigitalDeciZoomMin { get; set; }
            [DataMember(Order = 18, Name = "DigitalPTZSpeedMax")]
            public int DigitalPTZSpeedMax { get; set; }
            [DataMember(Order = 19, Name = "DigitalPTZSpeedMin")]
            public int DigitalPTZSpeedMin { get; set; }
            [DataMember(Order = 21, Name = "Mpeg2tsSize")]
            public string Mpeg2tsSize { get; set; }
            [DataMember(Order = 22, Name = "FrameRate")]
            public string FrameRate { get; set; }
            [DataMember(Order = 23, Name = "VideoSignalType")]
            public string VideoSignalType { get; set; }
        }


        public CookieContainer cookie;  // クッキー
        public bool receiving;          // セッション更新を継続するか

        public Form2()
        {
            InitializeComponent();
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            cookie = new CookieContainer();
            receiving = true;

            // Jsonコマンドの送信
            HttpWebRequest hReq;
            HttpWebResponse hRes;
            Cam_Feat cF = new Cam_Feat();
            Cam_Feat_Data cFD = new Cam_Feat_Data();
            Stream netStream;

            string session_start = constClass.PROTOCOL + Form1.F1Instance.ipAddr + ":" + Form1.F1Instance.port + constClass.URL_SESSION_START; // セッション取得用URL
            string continue_session = constClass.PROTOCOL + Form1.F1Instance.ipAddr + ":" + Form1.F1Instance.port + constClass.URL_CONTINUE_SESSION; //セッション更新用URL
            string session_end = constClass.PROTOCOL + Form1.F1Instance.ipAddr + ":" + Form1.F1Instance.port + constClass.URL_SESSION_END;  // セッション終了用URL
            string get_cam_info = constClass.PROTOCOL + Form1.F1Instance.ipAddr + ":" + Form1.F1Instance.port + constClass.URL_GET_CAM_INFO; // カメラの情報取得URL

            // セッションの取得
            hReq = (HttpWebRequest)HttpWebRequest.Create(session_start);
            hReq.Credentials = new NetworkCredential(Form1.F1Instance.adminuser, Form1.F1Instance.adminpass);
            hReq.CookieContainer = cookie;

            try
            {
                hRes = (HttpWebResponse)hReq.GetResponse();
            }
            catch (WebException wex)
            {
                if (wex.Status == WebExceptionStatus.ProtocolError)
                {
                    HttpWebResponse err = (HttpWebResponse)wex.Response;
                    switch (err.StatusCode)
                    {
                        case HttpStatusCode.Unauthorized:   // 401(認証失敗)の場合
                            MessageBox.Show(constClass.MESSAGE_AUTH_ERROR);
                            break;
                        case HttpStatusCode.ServiceUnavailable: // 503 (サーバーエラー)の場合
                            MessageBox.Show(constClass.MESSAGE_OTHER_ERROR);
                            break;
                        default:
                            MessageBox.Show(constClass.MESSAGE_UNKNOWN_ERROR);
                            Console.WriteLine(err.StatusCode);
                            break;
                    }
                }
                else
                {
                    if (wex.Status == WebExceptionStatus.Timeout) {
                        MessageBox.Show(constClass.MESSAGE_TIMEOUT_ERROR);
                    }
                    else
                    {
                        MessageBox.Show(constClass.MESSAGE_UNKNOWN_ERROR);
                        Console.WriteLine(wex);
                    }

                }
                this.Dispose();
            }

            hReq.Abort();



            // セッションの定期更新 //
            Thread thSession = new Thread(delegate() {

                HttpWebRequest sessionReq;
                int count = 0;
                int count_border = 10;

                while (receiving == true) {
                    sessionReq = (HttpWebRequest)HttpWebRequest.Create(continue_session);
                    sessionReq.CookieContainer = cookie;
                    try
                    {
                        sessionReq.GetResponse();
                    }
                    catch (WebException wex){
                        System.Diagnostics.Debug.WriteLine(wex);
                    }
                    sessionReq.Abort();
                    if (count == count_border)
                    {
                        Thread.Sleep(1000);
                        count = 0;
                    }
                    else {
                        count += 1;
                    }
                }

                // 終了前にセッション終了を通知する
                sessionReq = (HttpWebRequest)HttpWebRequest.Create(session_end);
                sessionReq.CookieContainer = cookie;
                try
                {
                    sessionReq.GetResponse();
                }
                catch (WebException wex) {
                    System.Diagnostics.Debug.WriteLine(wex);
                }
                sessionReq.Abort();

            });
            thSession.Start();





            //// 現在の設定値の取得
            hReq = (HttpWebRequest)HttpWebRequest.Create(get_cam_info);
            hReq.CookieContainer = cookie;
            hReq.Method = "GET";
            netStream = null;

            try {
                hRes = (HttpWebResponse)hReq.GetResponse();
                netStream = hRes.GetResponseStream();
            }
            catch {
                MessageBox.Show(constClass.MESSAGE_OTHER_ERROR);
                return;
            }

            string result = "";

            if (netStream != null)
            {
                result = getCamStream(netStream);
            }

            hReq.Abort();

            if (result == "OFF") {
                radioButton_OFF.Checked = true;
                return;
            }

            if (result == "1920x1080") {
                radioButton_HD.Checked = true;
                return;
            }

            radioButton_SD.Checked = true;




        }

        // 変更ボタン押下時の処理(ストリームの設定を変更する)
        private void button1_Click(object sender, EventArgs e)
        {
            HttpWebRequest hReq;
            string url = constClass.PROTOCOL + Form1.F1Instance.ipAddr + ":8000" + constClass.URL_SET_STREAM;

            setStreamCmd sCmd = new setStreamCmd();
            setStreamCmdParams sCmdData = new setStreamCmdParams();
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(setStreamCmd)); //
            MemoryStream ms = new MemoryStream();


            // コマンドの生成
            sCmd.Command = "SetStream";

            if (radioButton_OFF.Checked == true) {
                sCmdData.format = "JPEG";
            }
            if (radioButton_SD.Checked == true){
                sCmdData.format = "MPEG2TS_JPEG";
            }
            if (radioButton_HD.Checked == true){
                sCmdData.format = "MPEG2TSHD_JPEG";
            }
            sCmdData.rate = "1_2";

            sCmd.Data = sCmdData;
            serializer.WriteObject(ms, sCmd);
            byte[] buff = ms.ToArray();


            // HTTP Requestの生成
            hReq = (HttpWebRequest)HttpWebRequest.Create(url);
            hReq.ContentType = "application/json";
            hReq.Method = "POST";
            hReq.CookieContainer = cookie;
            hReq.ContentLength = buff.Length;
            hReq.ServicePoint.Expect100Continue = false;
            System.Diagnostics.Debug.WriteLine(Encoding.ASCII.GetString(buff));

            // Requestの送信
            Stream sendStream = hReq.GetRequestStream();
            sendStream.Write(buff, 0, buff.Length);
            sendStream.Close();

            // Responseの受信
            Stream recvStream = hReq.GetResponse().GetResponseStream();
            byte[] recvByte = new byte[1024];
            int readByte = recvStream.Read(recvByte, 0, recvByte.Length);
            ms.SetLength(0);
            ms.Write(recvByte, 0, readByte);
            recvByte = ms.ToArray();

            System.Diagnostics.Debug.WriteLine("Response="+Encoding.ASCII.GetString(recvByte)); //  リクエストを送るだけなら不要だが一応

            hReq.Abort();

            receiving = false;

            this.Dispose();

        }

        // キャンセルボタン押下時の処理
        private void button2_Click(object sender, EventArgs e)
        {
            receiving = false;
            this.Dispose();
        }



        // カメラのストリーム設定を取得する //
        public string getCamStream(Stream objStream)
        {
            Cam_Feat cF = new Cam_Feat();
            Cam_Feat_Data cFD = new Cam_Feat_Data();
            cF.Data = cFD;

            string result;

            MemoryStream ms = new MemoryStream();

            byte[] buff = new Byte[1024];    // ストリーム取得用のバッファ

            if (objStream != null)
            {
                int readByte = objStream.Read(buff, 0, buff.Count());

                ms.Write(buff, 0, readByte);
                System.Diagnostics.Debug.WriteLine(Encoding.ASCII.GetString(buff));
                ms.Seek(0, SeekOrigin.Begin);                     // 読み出し位置を先頭に戻す
                var serializer = new DataContractJsonSerializer(typeof(Cam_Feat));
                var rcv = serializer.ReadObject(ms) as Cam_Feat;  // ストリーム(JSON形式)のデータからオブジェクトに変換
                var dd = rcv.Data as Cam_Feat_Data;               // 受信したJSONデータからDataフィールド以下を取得

                result = dd.Mpeg2tsSize;

            }
            else {
                return null;
            }

            return result;
                
        }


    }

}
