﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Xml;

namespace WindowsFormsApplication1
{
    class xmlClass
    {
        // JPEGファイルを保存する
        // 設定ファイルの読み込み

        public int readSetting(string fileName)
        {

            if (File.Exists(fileName) == true)
            {
                XmlDocument doc = new XmlDocument();
                doc.Load(fileName);
                XmlNode root = doc.DocumentElement;
                XmlNode xNode;
                XmlNodeList nodeList;


                nodeList = root.SelectNodes("/setting/DIST_IP1");   // カメラIPアドレスの読み取り
                for (int i = 0; i < nodeList.Count; i++)
                {
                    xNode = nodeList[i];
                    Form1.F1Instance.text_ipAddr = xNode.InnerText;
                }

                nodeList = root.SelectNodes("/setting/DIST_PORT1"); // カメラポート番号の読み取り                
                for (int i = 0; i < nodeList.Count; i++)
                {
                    xNode = nodeList[i];
                    Form1.F1Instance.numeric_Port = int.Parse(xNode.InnerText);
                }

                nodeList = root.SelectNodes("/setting/SERV_PORT1"); // 待ちうけポート番号の読み取り
                for (int i = 0; i < nodeList.Count; i++) {
                    xNode = nodeList[i];
                    Form1.F1Instance.numeric_ServPort = int.Parse(xNode.InnerText);
                }

                nodeList = root.SelectNodes("/setting/USER1"); // ユーザー名の読み取り
                for (int i = 0; i < nodeList.Count; i++)
                {
                    xNode = nodeList[i];
                    Form1.F1Instance.text_user = reverseString(randomAppend_Delete(Encoding.UTF8.GetString(Convert.FromBase64String(xNode.InnerText)), false));
                }

                nodeList = root.SelectNodes("/setting/PASS1"); // パスワードの読み取り
                for (int i = 0; i < nodeList.Count; i++)
                {
                    xNode = nodeList[i];
                    Form1.F1Instance.text_pass = reverseString(randomAppend_Delete(Encoding.UTF8.GetString(Convert.FromBase64String(xNode.InnerText)), false));
                }

                nodeList = root.SelectNodes("/setting/ADMIN_USER"); //管理者ユーザー名の読み取り
                for (int i = 0; i < nodeList.Count; i++) {
                    xNode = nodeList[i];
                    Form1.F1Instance.text_adminUser = reverseString(randomAppend_Delete(Encoding.UTF8.GetString(Convert.FromBase64String(xNode.InnerText)), false));                
                }

                nodeList = root.SelectNodes("/setting/ADMIN_PASS"); //管理者ユーザー名の読み取り
                for (int i = 0; i < nodeList.Count; i++)
                {
                    xNode = nodeList[i];
                    Form1.F1Instance.text_adminPass = reverseString(randomAppend_Delete(Encoding.UTF8.GetString(Convert.FromBase64String(xNode.InnerText)), false));
                }

                nodeList = root.SelectNodes("/setting/USE_PROXY1"); // プロキシ使用のフラグの読み取り
                for (int i = 0; i < nodeList.Count; i++)
                {
                    xNode = nodeList[i];
                    if (((XmlElement)xNode).InnerText == "1")
                    {
                        Form1.F1Instance.checkBox_useProxy = true;
                    }
                    else {
                        Form1.F1Instance.checkBox_useProxy = false;
                    }
                }

                nodeList = root.SelectNodes("/setting/PATH_TO_VLC"); // パスワードの読み取り
                for (int i = 0; i < nodeList.Count; i++)
                {
                    xNode = nodeList[i];
                    Form1.F1Instance.applicationPath_to_VLC = xNode.InnerText;
                }

                nodeList = root.SelectNodes("/setting/USE_VLC"); // プロキシ使用のフラグの読み取り
                for (int i = 0; i < nodeList.Count; i++)
                {
                    xNode = nodeList[i];
                    if (((XmlElement)xNode).InnerText == "1")
                    {
                        Form1.F1Instance.checkBox_useVLC = true;
                    }
                    else
                    {
                        Form1.F1Instance.checkBox_useVLC = false;
                    }
                }

                return 0;
            }
                return -1;
        }


        // 設定ファイルの書き込み //
        public int writeSetting(string fileName)
        {
            XmlDocument doc = new XmlDocument();
            XmlDeclaration decla = doc.CreateXmlDeclaration("1.0", "UTF-8", null);
            XmlNode root = doc.CreateElement("setting");
            XmlElement element;

            doc.AppendChild(decla);
            doc.AppendChild(root);

            element = doc.CreateElement("USER1");
            element.InnerText = Convert.ToBase64String(Encoding.UTF8.GetBytes(randomAppend_Delete(reverseString(Form1.F1Instance.camuser), true)));
            root.AppendChild(element);

            element = doc.CreateElement("PASS1");
            element.InnerText = Convert.ToBase64String(Encoding.UTF8.GetBytes(randomAppend_Delete(reverseString(Form1.F1Instance.campass), true)));
            root.AppendChild(element);

            element = doc.CreateElement("ADMIN_USER");
            element.InnerText = Convert.ToBase64String(Encoding.UTF8.GetBytes(randomAppend_Delete(reverseString(Form1.F1Instance.adminuser), true)));
            root.AppendChild(element);

            element = doc.CreateElement("ADMIN_PASS");
            element.InnerText = Convert.ToBase64String(Encoding.UTF8.GetBytes(randomAppend_Delete(reverseString(Form1.F1Instance.adminpass), true)));
            root.AppendChild(element);
            
            element = doc.CreateElement("DIST_IP1");
            element.InnerText = Form1.F1Instance.ipAddr;
            root.AppendChild(element);

            element = doc.CreateElement("DIST_PORT1");
            element.InnerText = Form1.F1Instance.port.ToString();
            root.AppendChild(element);

            element = doc.CreateElement("SERV_PORT1");
            element.InnerText = Form1.F1Instance.serverPort.ToString();
            root.AppendChild(element);
            
            element = doc.CreateElement("USE_PROXY1");
            if (Form1.F1Instance.useProxy == true) {
                element.InnerText = "1";            
            } else {
                element.InnerText = "0";
            }
            root.AppendChild(element);

            element = doc.CreateElement("PATH_TO_VLC");
            element.InnerText = Form1.F1Instance.applicationPath_to_VLC;
            root.AppendChild(element);

            element = doc.CreateElement("USE_VLC");
            if (Form1.F1Instance.useVLC == true)
            {
                element.InnerText = "1";
            }
            else
            {
                element.InnerText = "0";
            }
            root.AppendChild(element);

            doc.Save(fileName);
            return 0;
        }


        // 文字列を逆転させるひっくり返す関数 
        public string reverseString(string instr_)
        {
            string tmp = "";

            for (int i = instr_.Length - 1; i >= 0; i--)
            {
                tmp = tmp + instr_.Substring(i, 1);
            }

            return tmp;
        }

        // 文字列にランダムな値を入れる関数
        public string randomAppend_Delete(string instr_, bool append)
        {
            string tmp = "";
            int randomNumber;

            Random rnd = new Random();

            if (append == true)
            {
                // ランダム値追加モード (奇数番目に数値を挿入)
                for (int i = 0; i < instr_.Length; i++)
                {
                    randomNumber = rnd.Next(10);
                    tmp = tmp + randomNumber + instr_.Substring(i, 1);
                }
            }
            else
            {

                //値削除モード (奇数番目の文字を取り除く)
                for (int i = 0; i < (instr_.Length / 2); i++)
                {
                    tmp = tmp + instr_.Substring(1 + 2 * i, 1);
                }
            }

            return tmp;
        }



    }
}
